/// @name       Camera2D.hpp
/// @desc       Camera viewport class for william. Includes utilities for vector-space transforms
/// @auth       Josh O'Leary
/// @edit       2023-09-09
/// @revision   1
/// @copyright  (c) 2023 Conari
/// @license    Unlicense - Public Domain

#include <vector>
#include "JUI/jui.h"
#include <glm/glm.hpp>

class Transform2D
{
public:

protected:
private:
};

namespace JUI {

    // TODO: Implement SparseMatrix next

    using uint = unsigned int;


    class Camera2D
    {
    #pragma region Interface
    public:
    #pragma region Constructors

    #pragma endregion

    #pragma region Member Methods
    #pragma region Getters
        v2f GetTopLeft();
    #pragma endregion

    #pragma region Setters

    #pragma endregion

    #pragma region

    #pragma endregion
        // World To Screen Coordinates
        v2f GetScreenPosition(v2f world_pos) const;

        // Screen To World Coordinates
        v2f GetWorldPosition(v2f screen_pos) const;

        v2f GetCameraPos() const;
        void SetCameraPos(v2f);

        SDL_Rect GetViewport();
        SDL_Rect GetVisibleArea();
        void Rotate(float radians);
        void RotateAboutPt(v2f pt, float radians);

    #pragma endregion
    #pragma region Implementation
    protected:
    private:
        v2f focal_pt; // The Gameworld Position currentlyat the center of the screen
        float rotation; // Rotation (in radians, about the camera's focal point)

    #pragma endregion

    };

}
