/// @file
/// @description
/// @author
/// @revision
/// @edited
/// @copyright
/// @license

#pragma once

// Universal Dimensions 1D
// A coordinate system data type for user interfaces specifically
// Contains a "Pixels" component and a "Scale" (percent but 0-1) component.
// @see-also UDim2.hpp
namespace JUI {
    class UDim;
}
// UDim unit shortcuts:
// Usage examples:
// 25_percent => UDim{0, 0.25f};
// 20_pixels + 10_percent => UDim{20, 0.10f};
#pragma region Unit Shorthands
JUI::UDim operator "" _scale(long double sc);
JUI::UDim operator "" _percent(unsigned long long pc);
JUI::UDim operator "" _pixels(unsigned long long px);
JUI::UDim operator "" _px(unsigned long long px);
#pragma endregion

namespace JUI {

    class UDim {
    public:
        int Pixels;
        float Scale;

    #pragma region Operators
        UDim operator+(const UDim& rhs) const;
        UDim operator-(const UDim& rhs) const;
        UDim operator*(float rhs) const;
        UDim operator/(float rhs) const;
    #pragma endregion

    #pragma region Constructors

        UDim() : Pixels(0), Scale(0.f) {}
        UDim(int pixels, float scale) : Pixels(pixels), Scale(scale) {}
        UDim(const UDim &u) = default;


    #pragma endregion

    #pragma region Methods

    #pragma endregion
private:
};
}