#pragma once

#include <JUI/Widgets/Rect.hpp>
#include <JUI/Widgets/Text.hpp>


namespace JUI {
    class Button : public Rect, public TextBase
    {
    public:
#pragma region Interface
#pragma region Events
        Event<> FocusGained;
        Event<> FocusDropped;
        Event<MouseButtonID> Pressed;
        Event<MouseButtonID> Released;
#pragma endregion
#pragma region Constructors
        Button();
        Button(Widget* parent);
#pragma endregion
#pragma region Getters
        SDL_Color GetBaseColor() const;
        SDL_Color GetHoverColor() const; // TODO: Implement hover color
        SDL_Color GetClickColor() const; // TODO: Implement click color
        bool GetEnabled() const { return enabled; }
#pragma endregion
#pragma region Setters
        void SetEnabled(bool e) {
            enabled = e;
            if (!enabled)
                this->SetBackgroundColor(disabled_color);
            else
                this->SetBackgroundColor(base_color);
        }
        void SetBaseColor(SDL_Color col);
        void SetHoverColor(SDL_Color col);
#pragma endregion
        void Draw(SDL_Renderer* target) override;
        void Update(double dt) override
        {
            Rect::Update(dt);
        }
#pragma endregion
    protected:
        bool enabled = true;
        SDL_Color disabled_color {64, 64, 64, 255};
        SDL_Color base_color {192, 192, 192, 192};
        SDL_Color hover_color {128, 128, 128, 255};
    private:
    };


    class ToggleButton : public Button {

    };
}