/// @file Texture.hpp
/// @desc Texture Widget class - Wrapper for SDL_Texture
/// @auth Josh O'Leary
/// @revision 1
/// @edited 2023-08-17
/// @copyright (c) 2023 Conarium Software
/// @license Unlicense - Public Domain


#pragma once

#include <JUI/Widgets/Widget.hpp>

#include <SDL_image.h>

namespace JUI {

    // Image Widget - container for SDL_Texture
    class Image : public Widget {
#pragma region Interface
    public:
#pragma region Constructors
        Image(); // Loads Dev Texture
        Image(Widget* parent);
        Image(Widget* parent, SDL_Texture* texture);

#pragma endregion
#pragma region Member Methods
        void Draw(SDL_Renderer* r) override;
        void Update(double delta) override;


#pragma region Getters
        v2f GetAbsoluteSize()     const override;
        v2f GetAbsolutePosition() const override;
        SDL_Texture* GetTexture() const;
#pragma endregion
#pragma region Setters
        void SetTexture(SDL_Texture* t);
#pragma endregion
#pragma endregion
#pragma region Events

#pragma endregion

#pragma endregion
#pragma region Internals
    protected:
        SDL_Texture* texture;
    private:
#pragma endregion
    };

}