/// @file Slider.hpp
/// @desc Slider Widget Class
/// @auth Joshua O'Leary
/// @revision 1
/// @edited 2023-08-17
/// @copyright (c) 2023 Conarium Software
/// @license Unlicense - Public Domain

#pragma once

#include <JUI/Widgets/Widget.hpp>
#include <JUI/Widgets/Rect.hpp>

namespace JUI {

    // Must be parented to a "Rect" Object to function
    class Slider : public Rect
    {
#pragma region Interface
    public:
#pragma region Constructors
        Slider();
        ~Slider() override;
#pragma endregion
#pragma region Events
        Event<float, float> DataChanged;
        Event<float, float> ScrubberMoved;
        Event<v2i> MouseEnterScrubber;
        Event<v2i> MouseExitScrubber;

#pragma endregion
#pragma region Member Methods
        void Draw(SDL_Renderer* target) override;
        void Update(double delta) override;
#pragma region Getters

#pragma endregion
#pragma region Setters
        void SetDataMinimum();
        void SetDataMaximum();
        void SetDataDefault();
        void SetDataIncrements();
        void SetSmoothScrubbing();
#pragma endregion
#pragma endregion
#pragma endregion
#pragma region Implementation
    protected:
    private:


#pragma endregion
    };

    void Slider::Draw(SDL_Renderer *target) {

    }
}