#pragma once

#include <SDL2/SDL.h>
#include <JUI/common.h>

enum gradient_dir{HORIZ, VERT};

// Implemented directly as 2 predefined directions
void gradient_rect(SDL_Renderer* r, gradient_dir direction,  SDL_Rect rect, SDL_Color start, SDL_Color end)
{
    if (direction == VERT)
    {
        int line_cnt = rect.h - rect.y;
        for (int y = 0; line_cnt > y; y++)
        {
            int line_x = rect.x;
            int line_y = rect.y + y;
            float alpha_dist = (float)y / (float)line_cnt;
            SDL_Color color = JUI::lerp_color(start, end, alpha_dist);
            SDL_SetRenderDrawColor(r, color.r, color.g, color.b, color.a);
            SDL_RenderDrawLine(r, line_x, line_y, line_x + rect.w, line_y);
        }
    }

    if (direction == HORIZ)
    {
        int column_cnt = rect.w - rect.x;
        for (int x = 0; column_cnt > x; x++)
        {
            int line_x = rect.x + x;
            int line_y = rect.y;

            float alpha_dist = (float)x / (float)column_cnt;
            SDL_Color color = lerp_color(start, end, alpha_dist);
            SDL_SetRenderDrawColor(r, color.r, color.g, color.b, color.a);
            SDL_RenderDrawLine(r, line_x, line_y, line_x, line_y + rect.h);
        }
    }
}