/// @file       jui.h
/// @desc       Josh's User Interface Toolkit (C++/SDL2 Edition)
/// @auth       Josh O'Leary
/// @revision   1
/// @edited     2023-05-20
/// @copyright  (C) 2023 Conarium Software
/// @license    Unlicense - Public Domain

#pragma once

#include <JUI/common.h>

#include <JUI/Types/Event.hpp>
#include <JUI/Types/Font.hpp>
#include <JUI/Types/UDim.hpp>
#include <JUI/Types/UDim2.hpp>

#include <JUI/Widgets/Scene.hpp>
#include <JUI/Widgets/Rect.hpp>
#include <JUI/Widgets/Image.hpp>
#include <JUI/Widgets/Text.hpp>
#include <JUI/Widgets/LayoutContainers.hpp>
#include <JUI/Widgets/Checkbox.hpp>

namespace JUI {
    // TODO: Write a synopsis of what JUI is, intended goals, features, and capabilities

    // Scene Widget
    // Core Widgets
    // Rect
    // Text
    // Slider
    // Composite Widgets
    // Window
    // DockableWindow
    // DockerRect
    // ScrollingWindow

    // Resources
    // https://discourse.libsdl.org/t/gradient-examples/8568/4
    // https://stackoverflow.com/questions/20348616/how-to-create-a-color-gradient-in-sdl
    // https://wiki.libsdl.org/SDL2/SDL_RenderDrawLine
    // https://gamedev.stackexchange.com/questions/71970/background-color-gradient-with-sdl
    // https://www.gamedev.net/forums/topic/344763-better-gradients-resolved/
    // https://www.gamedev.net/forums/topic/357847-sdl-gradient/
    // https://discourse.libsdl.org/t/sdl2-color-gradient/25408/5
    // https://discourse.libsdl.org/t/gradient-code/736/5
    // https://discourse.libsdl.org/t/font-color-gradients/15238/5
    // https://wiki.libsdl.org/SDL2/SDL_Surface
    // https://wiki.libsdl.org/SDL2/SDL_BlitSurface

    // Im already unhappy with the class structure
    // "Style" properties and "Data" properties could be given separate interface
}