
// Standalone mathematical functions

#pragma once

#include <cmath>

namespace JUI
{

    template <typename T>
    inline T SmoothStep(T val)
    {
        return val * val * (3.0f - 2.0f * val);
    }

    template <typename T>
    T Clamp(const T& val, const T& min, const T& max)
    {
        return std::max(min, std::min(max, val));
    }

    template <typename T>
    inline T Cube(T f) { return f * f * f; }


    template <typename T>
    inline T Square(T f) { return f * f; }



}



