//
// Created by josh on 8/15/23.
//


#include "JUI/Types/Font.hpp"

namespace JUI {


uint16_t Font::GetHeight(const std::string &formatted_text, ...) const {return FC_GetHeight(font_ptr, formatted_text.c_str());}

uint16_t Font::GetWidth(const std::string &formatted_text, ...) const { return FC_GetWidth(font_ptr, formatted_text.c_str()); }

int Font::GetAscent(const std::string &formatted_text, ...) const {return FC_GetAscent(font_ptr, formatted_text.c_str());}

int Font::GetBaseline() const {return FC_GetBaseline(font_ptr);}

int Font::GetSpacing() const {return FC_GetSpacing(font_ptr);}

int Font::GetLineSpacing() const {return FC_GetLineSpacing(font_ptr);}

uint16_t Font::GetMaxWidth() const { return FC_GetMaxWidth(font_ptr);}

SDL_Color Font::GetDefaultColor() const {return FC_GetDefaultColor(font_ptr);}

FC_FilterEnum Font::GetFilterMode() const { return FC_GetFilterMode(font_ptr);}

uint16_t Font::GetLineHeight() const { return FC_GetLineHeight(font_ptr); }

FC_Font *Font::GetCachedFontPtr() const { return font_ptr; }

Font::Font(SDL_Renderer *target, std::string font, int pt_size) {
    font_ptr = FC_CreateFont();

    FC_LoadFont(font_ptr, target, font.c_str(), pt_size, FC_MakeColor(255,255,255, 0), TTF_STYLE_NORMAL);
}

void Font::SetFilterMode(FC_FilterEnum filter) { FC_SetFilterMode(font_ptr, filter); }

void Font::SetSpacing(int letter_spacing) { FC_SetSpacing(font_ptr, letter_spacing);}

void Font::SetLineSpacing(int line_spacing) { FC_SetLineSpacing(font_ptr, line_spacing);}

void Font::SetDefaultColor(SDL_Color color) { FC_SetDefaultColor(font_ptr, color);}

    Font::~Font() {
        FC_FreeFont(this->font_ptr);
    }


}