#include <JUI/Types/UDim.hpp>

namespace JUI {
    UDim UDim::operator+(const UDim&rhs) const
    { return {Pixels+rhs.Pixels, Scale+rhs.Scale}; }
    UDim UDim::operator-(const UDim&rhs) const
    { return {Pixels-rhs.Pixels, Scale-rhs.Scale}; }
    UDim UDim::operator*(float rhs) const
    { return {static_cast<int>(Pixels*rhs), Scale*rhs}; }
    UDim UDim::operator/(float rhs) const { return {static_cast<int>(Pixels/rhs), Scale*rhs}; }
}

// special requirements on params for user-defined-literals?
using uint64ish  = unsigned long long;
using float64ish = long double;

JUI::UDim operator "" _scale(float64ish sc) { return {0, static_cast<float>(sc)}; }
JUI::UDim operator "" _percent(uint64ish pc) { return {0, pc/100.0f}; }
JUI::UDim operator "" _pixels(uint64ish px)  { return {static_cast<int>(px), 0.0f}; }
JUI::UDim operator "" _px    (uint64ish px)  { return {static_cast<int>(px), 0.0f}; }
