#include <JUI/Widgets/Button.hpp>


void JUI::Button::Draw(SDL_Renderer *target) {
    Rect::Draw(target);
    TextBase::Draw(target, this->GetAbsolutePosition(), this->GetAbsoluteSize());
}

JUI::Button::Button() : Rect(), TextBase() {
    this->MouseEnter += [&](v2i c) {

        if (enabled)
            this->SetBackgroundColor(hover_color);
    };
    this->MouseExit  += [&](v2i c) {
        if (enabled)
            this->SetBackgroundColor(base_color);
    };
}

JUI::Button::Button(JUI::Widget *parent) : Button()
{
    this->SetParent(parent);
}

SDL_Color JUI::Button::GetBaseColor() const {
    return base_color;
}

SDL_Color JUI::Button::GetHoverColor() const {
    return hover_color;
}

void JUI::Button::SetHoverColor(SDL_Color col) {
    hover_color = col;
}

void JUI::Button::SetBaseColor(SDL_Color col) {
    base_color = col;
    SetBackgroundColor(base_color);
}

