#include <JUI/Widgets/Checkbox.hpp>


namespace JUI
{

    Checkbox::Checkbox() : Rect() {
        this->SetSize({25_px, 25_px});
        this->SetBorderRadius(10.f);

        this->MouseReleased += [this] (MouseButtonID mousebtn)
        {
            if (mousebtn == MouseButtonID::LMB)
            {
                this->checked = !this->checked;
            }
        };
    }

    Checkbox::Checkbox(Widget *parent) : Checkbox()
    {
        this->SetParent(parent);
    }

    void Checkbox::Update(double delta) {
        Rect::Update(delta);

        if (IsMouseInside())
        {

        }
    }

    void Checkbox::Draw(SDL_Renderer* target) {
        Rect::Draw(target);

        auto* texture = JUI::GetCheckmark();

        auto image_dimensions = JUI::GetTextureDimensions(texture);
        auto abs_pos = GetAbsolutePosition();
        auto abs_size = GetAbsoluteSize();

        if (checked)
        {
            SDL_Rect source_rect = {0, 0, image_dimensions.x, image_dimensions.y};
            SDL_Rect output_rect = {
                    static_cast<int>(abs_pos.x),
                    static_cast<int>(abs_pos.y),
                    static_cast<int>(abs_size.x),
                    static_cast<int>(abs_size.y)};

            SDL_RenderCopy(target, texture, &source_rect, &output_rect);
        }
    }

    Checkbox::~Checkbox() = default;
}