#include <JUI/common.h>
#include <JUI/Widgets/Text.hpp>

namespace JUI {
    Text::Text() : Widget(), TextBase() {

    }

    Text::Text(Widget* parent) : Text() {
        this->SetParent(parent);
    }

    Text::Text(Widget* parent, const std::string& text) : Text(parent)
    { this->SetText(text); }

    Text::~Text() = default;
    v2f Text::GetAbsoluteSize()     const { return this->GetParent()->GetAbsoluteSize(); }
    v2f Text::GetAbsolutePosition() const { return this->GetParent()->GetAbsolutePosition(); }
    void Text::Draw(SDL_Renderer *target){
        // TODO: Implement Word Wrap with FC_DrawColumn...()

        v2f abs_pos  = this->GetAbsolutePosition();
        v2f abs_size = this->GetAbsoluteSize();

        TextBase::Draw(target, abs_pos, abs_size);

        Widget::Draw(target);
    }

    void Text::Update(double delta) {
        //TextBase::Update(delta);
        Widget::Update(delta);
    }




}